// NoButtonArea.js Ver.1.0.1
// MIT License (C) 2022 あわやまたな
// http://opensource.org/licenses/mit-license.php

/*:
* @target MZ
* @plugindesc ボタンエリアを確保しません。
* @author あわやまたな (Awaya_Matana)
* @url https://awaya3ji.seesaa.net/article/494375691.html
* @help ボタンエリアを除去し、ボタンの不透明度を下げることで
* 画面表示領域を目一杯にします。
*
* [更新履歴]
* 2022/12/03：Ver.1.0.0　公開。
* 2023/04/05：Ver.1.0.1　仮想ボタンのタップがウィンドウに干渉する不具合を修正。
*
*/

'use strict';

{
	//-----------------------------------------------------------------------------
	// Scene_MenuBase

	Scene_MenuBase.prototype.buttonAreaBottom = function() {
		return 0;
	};

	Scene_MenuBase.prototype.mainAreaHeight = function() {
		return Graphics.boxHeight - this.helpAreaHeight();
	};

	//-----------------------------------------------------------------------------
	// Sprite_Button

	Sprite_Button.prototype.updateOpacity = function() {
		this.opacity = this._pressed ? 224 : 160;
	};

	const _Sprite_Button_onClick = Sprite_Button.prototype.onClick;
	Sprite_Button.prototype.onClick = function() {
		_Sprite_Button_onClick.call(this);
		Input.update();
	};

}